<?php

/**
 * inf_anual_titulo actions.
 *
 * @package    canon
 * @subpackage inf_anual_titulo
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_anual_tituloActions extends sfActions {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */
            $whereCompetencia = ' ';
            if (isset($request['id_competencia'])) {
                $whereCompetencia = " AND tab0.id_competencia = '" . $request['id_competencia'] . "' ";
            }
            $whereLiquidado = ' ';
            if (isset($request['liquidado'])) {
                $whereLiquidado = " AND tab0.liquidado = '" . $request['liquidado'] . "' ";
            }
            $whereTitulo = ' ';
            if (isset($request['id_titulo'])) {
                $whereTitulo = " AND tab0.id_titulo = '" . $request['id_titulo'] . "' ";
            }
            $whereModulo = ' ';
            if (isset($request['id_modulo'])) {
                $whereModulo = " AND tab1.id_modulo = '" . $request['id_modulo'] . "' ";
            }

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from(
 
      SELECT TAB0.*
, CASE WHEN PAGO = 1 THEN 'X' ELSE ' ' END AS PAGO_TXT
FROM (
SELECT TAB.* ,
SYSDATE,
(SELECT DESCRIPCION FROM CA_NORMA_CANON WHERE TAB.ID_NORMA = ID_NORMA) AS LEY,
(SELECT NOMBRE FROM RMN_COMPETENCIA WHERE ID_COMPETENCIA = TAB.ID_COMPETENCIA) AS COMPETENCIA,
(SELECT NUM_RECIBO  FROM CA_RECIBO WHERE TAB.ID_DET_LIQ_CANON = ID_DET_LIQ_CANON AND VIGENCIA = TAB.VIGENCIA_LIQ AND ROWNUM = 1) AS NUM_REC,
(SELECT PAGO  FROM CA_RECIBO WHERE TAB.ID_DET_LIQ_CANON = ID_DET_LIQ_CANON AND VIGENCIA = TAB.VIGENCIA_LIQ AND ROWNUM = 1) AS PAGO,
(SELECT ID_RECIBO  FROM CA_RECIBO WHERE TAB.ID_DET_LIQ_CANON = ID_DET_LIQ_CANON AND VIGENCIA = TAB.VIGENCIA_LIQ AND ROWNUM = 1) AS ID_RECIBO
FROM
(SELECT
(select l.id_competencia from ca_liq_canon l WHERE d.id_liq_canon = l.id_liq_canon and l.vigencia = d.vigencia AND d.id_titulo = id_titulo and rownum = 1) as ID_COMPETENCIA,
E.ID_ANUAL_ETAPA,
E.ID_TITULO_ETAPA,
E.ID_TITULO,
substr(to_char(T.FECHA_INICIO, 'dd/mm/yyyy'),7) AS VIGENCIA,
E.ANUALIDAD,
E.FECHA_INICIO,
E.FECHA_FIN,
E.ESTADO,
E.LIQUIDADO,
(CASE WHEN E.LIQUIDADO = 1 THEN 'LIQUIDADO'ELSE 'SIN LIQUIDAR' END )AS ESTADO_LIQ,
E.IMPRESO,
(SELECT COD_TITULO FROM RMN_TITULO WHERE ID_TITULO = E.ID_TITULO) as cod_rmn,
(SELECT FECHA_INSCRIPCION_RMN FROM RMN_TITULO WHERE ID_TITULO = E.ID_TITULO) as FECHA_RMN,
(SELECT ID_NORMA FROM CA_TITULO_NORMA N WHERE N.ID_TITULO = E.ID_TITULO AND ACTUAL = 1) AS ID_NORMA,
(SELECT NOMBRE FROM CA_ETAPA WHERE ID_ETAPA = T.ID_ETAPA) AS NOMBRE_ETAPA,
D.ID_DET_LIQ_CANON AS ID_DET_LIQ_CANON,
CASE WHEN D.VALOR = -1 THEN 0 ELSE D.VALOR END  AS VALOR,
D.ID_LIQ_CANON AS ID_LIQ_CANON,
D.VIGENCIA  AS VIGENCIA_LIQ,
D.FECHA_APRUEBA  AS FECHA_APRUEBA,
T.ID_ETAPA,
T.FECHA_INICIO AS FECHA_INICIO_T,
T.FECHA_FIN AS FECHA_FIN_T,
T.FECHA_INSCRIPCION,
T.ESTADO AS ESTADO_T,
T.ACTUAL AS ACTUAL_T,
CASE WHEN P.VALOR_PAGO = -1 THEN 0 ELSE P.VALOR_PAGO END AS VALOR_PAGO_HIS
FROM CA_TITULO_ETAPA T
JOIN CA_ANUAL_ETAPA E ON
E.ID_TITULO_ETAPA = T.ID_TITULO_ETAPA
AND E.ID_TITULO = T.ID_TITULO
LEFT JOIN CA_DET_LIQ_CANON  D ON
D.ID_ANUAL_ETAPA = E.ID_ANUAL_ETAPA
AND D.ANULADO = 0
LEFT JOIN CA_RECIBO R ON
R.ID_DET_LIQ_CANON = D.ID_DET_LIQ_CANON
AND R.VIGENCIA = D.VIGENCIA
LEFT JOIN CA_PAGO_HISTOTICO P ON
P.ID_RECIBO = R.ID_RECIBO
AND P.VIGENCIA = R.VIGENCIA
WHERE 1 = 1
AND T.ACTUAL = 1
)TAB )TAB0
WHERE 1 = 1
AND tab0.FECHA_RMN > TO_DATE('31/12/2000', 'DD/MM/YYYY')
$whereCompetencia
$whereLiquidado
$whereTitulo
ORDER BY ID_TITULO, ID_ETAPA, ANUALIDAD
 
)tabla
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            //validar si hay registros
            if ($total_record_count > 0) {


                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
      
      SELECT TAB0.*
, CASE WHEN PAGO = 1 THEN 'X' ELSE ' ' END AS PAGO_TXT
FROM (
SELECT TAB.* ,
SYSDATE,
(SELECT DESCRIPCION FROM CA_NORMA_CANON WHERE TAB.ID_NORMA = ID_NORMA) AS LEY,
(SELECT NOMBRE FROM RMN_COMPETENCIA WHERE ID_COMPETENCIA = TAB.ID_COMPETENCIA) AS COMPETENCIA,
(SELECT NUM_RECIBO  FROM CA_RECIBO WHERE TAB.ID_DET_LIQ_CANON = ID_DET_LIQ_CANON AND VIGENCIA = TAB.VIGENCIA_LIQ AND ROWNUM = 1) AS NUM_REC,
(SELECT PAGO  FROM CA_RECIBO WHERE TAB.ID_DET_LIQ_CANON = ID_DET_LIQ_CANON AND VIGENCIA = TAB.VIGENCIA_LIQ AND ROWNUM = 1) AS PAGO,
(SELECT ID_RECIBO  FROM CA_RECIBO WHERE TAB.ID_DET_LIQ_CANON = ID_DET_LIQ_CANON AND VIGENCIA = TAB.VIGENCIA_LIQ AND ROWNUM = 1) AS ID_RECIBO
FROM
(SELECT
(select l.id_competencia from ca_liq_canon l WHERE d.id_liq_canon = l.id_liq_canon and l.vigencia = d.vigencia AND d.id_titulo = id_titulo and rownum = 1) as ID_COMPETENCIA,
E.ID_ANUAL_ETAPA,
E.ID_TITULO_ETAPA,
E.ID_TITULO,
substr(to_char(T.FECHA_INICIO, 'dd/mm/yyyy'),7) AS VIGENCIA,
E.ANUALIDAD,
E.FECHA_INICIO,
E.FECHA_FIN,
E.ESTADO,
E.LIQUIDADO,
(CASE WHEN E.LIQUIDADO = 1 THEN 'LIQUIDADO'ELSE 'SIN LIQUIDAR' END )AS ESTADO_LIQ,
E.IMPRESO,
(SELECT COD_TITULO FROM RMN_TITULO WHERE ID_TITULO = E.ID_TITULO) as cod_rmn,
(SELECT FECHA_INSCRIPCION_RMN FROM RMN_TITULO WHERE ID_TITULO = E.ID_TITULO) as FECHA_RMN,
(SELECT ID_NORMA FROM CA_TITULO_NORMA N WHERE N.ID_TITULO = E.ID_TITULO AND ACTUAL = 1) AS ID_NORMA,
(SELECT NOMBRE FROM CA_ETAPA WHERE ID_ETAPA = T.ID_ETAPA) AS NOMBRE_ETAPA,
D.ID_DET_LIQ_CANON AS ID_DET_LIQ_CANON,
CASE WHEN D.VALOR = -1 THEN 0 ELSE D.VALOR END  AS VALOR,
D.ID_LIQ_CANON AS ID_LIQ_CANON,
D.VIGENCIA  AS VIGENCIA_LIQ,
D.FECHA_APRUEBA  AS FECHA_APRUEBA,
T.ID_ETAPA,
T.FECHA_INICIO AS FECHA_INICIO_T,
T.FECHA_FIN AS FECHA_FIN_T,
T.FECHA_INSCRIPCION,
T.ESTADO AS ESTADO_T,
T.ACTUAL AS ACTUAL_T,
CASE WHEN P.VALOR_PAGO = -1 THEN 0 ELSE P.VALOR_PAGO END AS VALOR_PAGO_HIS
FROM CA_TITULO_ETAPA T
JOIN CA_ANUAL_ETAPA E ON
E.ID_TITULO_ETAPA = T.ID_TITULO_ETAPA
AND E.ID_TITULO = T.ID_TITULO
LEFT JOIN CA_DET_LIQ_CANON  D ON
D.ID_ANUAL_ETAPA = E.ID_ANUAL_ETAPA
AND D.ANULADO = 0
LEFT JOIN CA_RECIBO R ON
R.ID_DET_LIQ_CANON = D.ID_DET_LIQ_CANON
AND R.VIGENCIA = D.VIGENCIA
LEFT JOIN CA_PAGO_HISTOTICO P ON
P.ID_RECIBO = R.ID_RECIBO
AND P.VIGENCIA = R.VIGENCIA
WHERE 1 = 1
AND T.ACTUAL = 1
)TAB )TAB0
WHERE 1 = 1
AND tab0.FECHA_RMN > TO_DATE('31/12/2000', 'DD/MM/YYYY')
$whereCompetencia
$whereLiquidado
$whereTitulo
ORDER BY ID_TITULO, ID_ETAPA, ANUALIDAD 
            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);

                // Solo registra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_recibo');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                    $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd, "Se generó un informe general de título");
                }

                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[INFORME_GEN_TITULO] Consulta exitosa.");
            } else {

                $mensaje = "[INFORME_GEN_TITULO] No hay registros de consulta.";
                $this->status = 1;
                $this->mensajeError = $mensaje;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {

            $error = "[INFORME_GEN_TITULO] ERROR: " . $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

}
